/***********************************************************************
/* _quicksort
 * Quick sort for the point array. Note that there are 3 ints associated 
 * with each point!
*/

#define SWAP3(list, i, j)		\
{register int *pi, *pj, tmp;		\
	pi=list+3*(i); pj=list+3*(j); 	\
					\
	tmp=*pi;			\
	*pi++=*pj;			\
	*pj++=tmp;			\
					\
	tmp=*pi;			\
	*pi++=*pj;			\
	*pj++=tmp;			\
					\
	tmp=*pi;			\
	*pi=*pj;			\
	*pj=tmp;			\
}

int _quicksort(int *pointlist, int n)
{
      unsigned i, j, ln, rn;

      while (n > 1)
      {
	    SWAP3(pointlist, 0, n/2);
            for (i = 0, j = n; ; )
            {
                  do
                        --j;
                  while (pointlist[3*j+2] < pointlist[2]);
                  do
                        ++i;
                  while (i < j && pointlist[3*i+2] > pointlist[2]);
                  if (i >= j)
                        break;
                  SWAP3(pointlist, i, j);
            }
            SWAP3(pointlist, j, 0);
            ln = j;
            rn = n - ++j;
            if (ln < rn)
            {
                  _quicksort(pointlist, ln);
                  pointlist += 3*j;
                  n = rn;
            }
            else
            {
                  _quicksort(pointlist + 3*j, rn);
                  n = ln;
            }
      }
}
#undef SWAP3

